package keystash.gui;

import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import keystash.KeyStashGUI;
import static keystash.KeyStashGUI.decryptDatabaseFrame;
import static keystash.KeyStashGUI.isWalletEncrypted;
import keystash.util.Constants;
import keystash.util.Db;

public class BackupFile {

    static public void backupWalletFile() {

        Db.walletClose();

        String f = Constants.walletPath;

        JFileChooser chooser = new JFileChooser();
        chooser.setSelectedFile(new File("wallet.h2.db"));
        chooser.setDialogTitle("Specify a directory to save");

        int userSelection = chooser.showSaveDialog(chooser);
        if (userSelection == JFileChooser.APPROVE_OPTION) {

            DataInputStream dis = null;
            try {
                dis = new DataInputStream(new FileInputStream(f));
            } catch (FileNotFoundException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            ByteArrayOutputStream buffer = new ByteArrayOutputStream();

            int nRead;
            byte[] data = null;
            try {
                data = new byte[dis.available()];
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }

            try {
                while ((nRead = dis.read(data, 0, data.length)) != -1) {
                    buffer.write(data, 0, nRead);
                }
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }

            try {
                buffer.flush();
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }

            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            DataOutputStream dataOutStream = new DataOutputStream(baos);
            try {
                dataOutStream.write(data);
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }

            OutputStream outputStream = null;
            try {
                outputStream = new FileOutputStream(chooser.getSelectedFile());
            } catch (FileNotFoundException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                baos.writeTo(outputStream);
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                baos.close(); //Lets close some streams 
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                dataOutStream.close();
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                outputStream.close();
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                buffer.close();
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                dis.close();
                Dialog.showDialog("Wallet backup saved!", "Note");
            } catch (IOException ex) {
                Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
            }

        }

        try {
            Db.connectToWallet();

        } catch (Exception e) {
            System.err.println("Database looks encrypted. Enter master password.");
            isWalletEncrypted = true;
        }

        if (isWalletEncrypted) {
            TableContent.deleteGuiTables();
            Dialog.showDialog("Your database is encrypted re-enter master password to connect.", "Note");
            MenuItem.encryptedEnableMenu(false);
            decryptDatabaseFrame.setVisible(true);
            decryptDatabaseFrame.setLocationRelativeTo(null);
        }

    }

}
