package keystash.gui;

import static keystash.KeyStashGUI.decryptDatabaseFrame;
import static keystash.KeyStashGUI.decryptDatabasePasswordField;
import static keystash.KeyStashGUI.decryptDatabaseShowPhraseCheckBox;
import static keystash.KeyStashGUI.encryptDatabaseMenuItem;
import keystash.util.Constants;
import keystash.util.Db;
import keystash.util.Memory;

public class DecryptDatabase {

    public static void doDecrypt() {

        char[] checkPassword = decryptDatabasePasswordField.getPassword();
        char c = '¡';

        if (checkPassword.length < Constants.minPasswordChars) {
            Dialog.showDialog("Password must contain at least " + Constants.minPasswordChars + " characters!", "Note");
        }
        else if (new String(checkPassword).contains(Character.toString(c))) {
            Dialog.showDialog("No ¡ character allowed in password.", "Note");
        }
        else {
            try {
                decryptDatabasePasswordField.setText("");
                decryptDatabaseFrame.setVisible(false);
                Db.connectToEncryptedWallet(String.valueOf(checkPassword).replace(' ', c));
                TableContent.getTable();
                encryptDatabaseMenuItem.setEnabled(false);
                MenuItem.encryptedEnableMenu(true);
            } catch (Exception e) {
                Dialog.showDialog("Wrong pasword, decryption failed.", "Note");
                decryptDatabaseFrame.setVisible(true);
            }

        }
        Memory.clearPasswordMemory(checkPassword);

    }

    public static void showPhrase() {

        boolean showPhrase = decryptDatabaseShowPhraseCheckBox.isSelected();

        if (showPhrase) {
            decryptDatabasePasswordField.setEchoChar((char) 0);
        }
        else {
            decryptDatabasePasswordField.setEchoChar('*');
        }

    }

}
