package keystash.gui;

import java.security.NoSuchAlgorithmException;
import javax.swing.table.DefaultTableModel;
import keystash.KeyStashGUI;
import static keystash.KeyStashGUI.aboutTable;
import static keystash.KeyStashGUI.accountTable;
import static keystash.KeyStashGUI.row;
import static keystash.KeyStashGUI.showDetailPopup;
import keystash.util.Constants;
import keystash.util.Db;
import static keystash.crypto.KeyLength.isUnlimitedKeyStrength;


public class TableContent {
    
       public static void getTable() {

        int countRows = Db.countAccountsWallet("keystash_wallet") + 1;

        String[] getAccountid = new String[countRows];
        String[] getAddressRs = new String[countRows];
        String[] getLabel = new String[countRows];
        String[] getTimestamp = new String[countRows];

        for (int i = 1; i < countRows; i++) {
            getAccountid[i] = Db.selectFromWallet("account_id", "keystash_wallet", "account_id", +i);
            getAddressRs[i] = Db.selectFromWallet("address_rs", "keystash_wallet", "account_id", +i);
            getLabel[i] = Db.selectFromWallet("label", "keystash_wallet", "account_id", +i);
            getTimestamp[i] = Db.selectFromWallet("created_timestamp", "keystash_wallet", "account_id", +i);
            Object[] row = {getAccountid[i] + ".", getAddressRs[i], getLabel[i], getTimestamp[i]};
            DefaultTableModel model = (DefaultTableModel) accountTable.getModel();
            model.addRow(row);
        }

    }

    public static void insertAboutComponents()
            throws NoSuchAlgorithmException {

        DefaultTableModel model = (DefaultTableModel) aboutTable.getModel();
        Object[] rowVersion = {"KeyStash", Constants.keyStashVersion};
        model.addRow(rowVersion);

        boolean isMaxKeyLength = isUnlimitedKeyStrength();
        Object[] rowKeySize = {"Unlimited Key Length(\"AES\")", isMaxKeyLength};
        model.addRow(rowKeySize);

        Object[] rowApi = {"Api URL", Constants.apiAddress};
        model.addRow(rowApi);

        Object[] rowHomeFolder = {"Database Home Folder", Constants.walletPathOnly};
        model.addRow(rowHomeFolder);

    }

    public static void deleteGuiTables() {

        DefaultTableModel model = (DefaultTableModel) accountTable.getModel();
        int rows = model.getRowCount();
        for (int i = rows - 1; i >= 0; i--) {
            model.removeRow(i);
        }

    }
    

}
