package keystash.http;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import keystash.util.Constants;
import keystash.util.Db;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.ServerConnector;
import org.eclipse.jetty.servlet.ServletHandler;

public class Api {

    public static Server server;

    static int countRows = Db.countAccountsWallet("keystash_wallet");
    static String[] id;
    static String[] cl;
    static String[] rs;
    static String[] pKey;
    static String[] lab;
    static String[] se;
    static String[] raSalt;
    static String[] raIV;
    static String[] sIt;
    static String[] sKey;
    static String[] sA;
    static String[] aT;
    static String[] timestamp;

    public static void getWalletData(int rows, String[] account_id, String[] addressClassic, String[] addressRs, String[] publicKey, String[] label, String[] secret, String[] randomSalt, String[] randomIV, String[] secretIterations, String[] secretKeySize, String[] shareAccount, String[] accountType, String[] createdTimestamp) {

        countRows = rows;
        id = account_id;
        cl = addressClassic;
        rs = addressRs;
        pKey = publicKey;
        lab = label;
        se = secret;
        raSalt = randomSalt;
        raIV = randomIV;
        sIt = secretIterations;
        sKey = secretKeySize;
        sA = shareAccount;
        aT = accountType;
        timestamp = createdTimestamp;

    }

    public static void startWalletServer(boolean statusServer)
            throws IOException,
            Exception {

        boolean isRunning = statusServer;

        if (isRunning) {
            server = new Server();
            ServerConnector connector;
            connector = new ServerConnector(server);
            connector.setPort(Constants.apiPort);
            connector.setHost(Constants.apiHost);
            server.addConnector(connector);
            ServletHandler apiHandler = new ServletHandler();
            server.setHandler(apiHandler);
            server.setStopAtShutdown(true);
            apiHandler.addServletWithMapping(WalletApi.class, "/keystash");
            try {
                server.start();
            } catch (Exception e) {
                System.err.println("Failed to start api server.");
            }

        }
        if (!isRunning) {
            try {
                server.setStopTimeout(10000L);
                server.stop();
            } catch (Exception e) {
                System.err.println("Failed to stop api server.");
            }
        }

    }

    public static class WalletApi extends HttpServlet {

        @Override
        protected void doGet(HttpServletRequest request, HttpServletResponse response)
                throws ServletException,
                IOException {

            response.setContentType("text/javascript");
            response.setStatus(HttpServletResponse.SC_OK);
            response.getWriter().println("Wallet({");
            response.getWriter().println("\"Accounts" + "\": [");

            if (countRows == 0) {
                response.getWriter().println("{\"AccountQuantity" + "\": \"0" + "\"}");
                response.getWriter().println("]});");
            }
            else {
                for (int i = 1; i < countRows + 1; i++) {
                    response.getWriter().println("{\"AccountId" + "\": \"" + id[i] + "\", \"AddressClassic" + "\": \"" + cl[i] + "\", \"AddressRs" + "\": \"" + rs[i] + "\", \"PublicKey" + "\": \"" + pKey[i] + "\", \"Label" + "\": \"" + lab[i] + "\", \"Secret" + "\": \"" + se[i] + "\", \"RandomSalt" + "\": \"" + raSalt[i] + "\", \"RandomIV" + "\": \"" + raIV[i] + "\", \"SecretIteration" + "\": \"" + sIt[i] + "\", \"SecretKeySize" + "\": \"" + sKey[i] + "\", \"ShareAccount" + "\": \"" + sA[i] + "\", \"AccountType" + "\": \"" + aT[i] + "\", \"CreatedDate" + "\": \"" + timestamp[i] + "\"}");
                    
                    if (i == countRows) {
                    }
                    else {
                        response.getWriter().println(", ");
                    }
                }
                response.getWriter().println("]});");
            }
        }
    }
    
}