package keystash.util;

import java.sql.*;
import keystash.gui.Dialog;
import org.h2.jdbcx.JdbcDataSource;

public class Db {

    static Connection wallet;
    static Connection settings;

    public static void connectToWallet() {

        JdbcDataSource ds = new JdbcDataSource();
        ds.setURL(Constants.walletDbName);
        ds.setUser(Constants.dbUsernameWallet);
        ds.setPassword(Constants.dbPasswordWallet);

        try {
            wallet = ds.getConnection();
        } catch (SQLException e) {
            System.err.println("Database wallet probably encrypted or already in use.");
        } finally {
        }

    }

    public static void connectToEncryptedWallet(String password) {

        String p = password + " " + Constants.dbPasswordWallet;
        JdbcDataSource ds = new JdbcDataSource();
        ds.setURL(Constants.walletDbNameEncrypt);
        ds.setUser(Constants.dbUsernameWallet);
        ds.setPassword(p);

        try {
            wallet = ds.getConnection();
        } catch (SQLException e) {
            System.err.println("Wrong master password or database encrypted wallet already in use .");
        } finally {
        }

    }

    public static void connectToSettings() {

        JdbcDataSource ds = new JdbcDataSource();
        ds.setURL(Constants.settingsDbName);
        ds.setUser(Constants.dbUsernameSettings);
        ds.setPassword(Constants.dbPasswordSettings);

        try {
            settings = ds.getConnection();
        } catch (SQLException e) {
            Dialog.showDialog("Database settings took to long to load or KeyStash is already running.", "Note");
            System.exit(0);
        } finally {
        }

    }

    public static void walletInsert(String sqlstmt) {

        Statement stmt;

        try {
            stmt = wallet.createStatement();
            stmt.executeUpdate(sqlstmt);
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Database wallet insert not possible.");
        }

    }

    public static void settingsInsert(String sqlstmt) {

        Statement stmt;

        try {
            stmt = settings.createStatement();
            stmt.executeUpdate(sqlstmt);
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Database settings insert not possible.");
        }

    }

    public static void walletInsertNewAccount(int accountId, String addressClassic, String addressRs, String publicKey, String label, String secret, String randomSalt, String randomIV, int secretIteration, int secretKeySize, int shareAccount, String accountType, String createdTimestamp) {

        String insertstmt = "insert into keystash_wallet values(";
        String insertstmtclose = ")";
        String decimal = ", ";
        String invertDecimal = "'";
        String sqlstmt = insertstmt + accountId + decimal + invertDecimal + addressClassic + invertDecimal + decimal + invertDecimal + addressRs + invertDecimal + decimal + invertDecimal + publicKey + invertDecimal + decimal + invertDecimal + label + invertDecimal + decimal + invertDecimal + secret + invertDecimal + decimal + invertDecimal + randomSalt + invertDecimal + decimal + invertDecimal + randomIV + invertDecimal + decimal + invertDecimal + secretIteration + invertDecimal + decimal + invertDecimal + secretKeySize + invertDecimal + decimal + invertDecimal + shareAccount + invertDecimal + decimal + invertDecimal + accountType + invertDecimal + decimal + invertDecimal + createdTimestamp + invertDecimal + insertstmtclose;

        Statement stmt;
        try {
            stmt = wallet.createStatement();
            stmt.executeUpdate(sqlstmt);
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Database wallet insert not possible.");
        }
    }

    public static void walletInsertSettings(int settingsId, String lazyWalletVersion, boolean loadFromDevice, boolean showWarnings, int clearClipboard, int phraseBlocks, int secretIteration, int secretKeySize, int shareAccount, String accountType, boolean enableWhitespace, boolean enableAnsi, boolean randomGeneration, int lengthMinimumMin, int lengthMinimumMax, int lengthMaximumMin, int lengthMaximumMax, int lowerCaseMin, int lowerCaseMax, int upperCaseMin, int upperCaseMax, int numeraryMin, int numeraryMax, int specialCharMin, int specialCharMax) {

        String insertstmt = "insert into keystash_settings values(";
        String insertstmtclose = ")";
        String decimal = ", ";
        String invertDecimal = "'";
        String sqlstmt = insertstmt + settingsId + decimal + invertDecimal + lazyWalletVersion + invertDecimal + decimal + invertDecimal + loadFromDevice + invertDecimal + decimal + invertDecimal + showWarnings + invertDecimal + decimal + invertDecimal + clearClipboard + invertDecimal + decimal + invertDecimal + phraseBlocks + invertDecimal + decimal + invertDecimal + secretIteration + invertDecimal + decimal + invertDecimal + secretKeySize + invertDecimal + decimal + invertDecimal + shareAccount + invertDecimal + decimal + invertDecimal + accountType + invertDecimal + decimal + invertDecimal + enableWhitespace + invertDecimal + decimal + invertDecimal + enableAnsi + invertDecimal + decimal + invertDecimal + randomGeneration + invertDecimal + decimal + invertDecimal + lengthMinimumMin + invertDecimal + decimal + invertDecimal + lengthMinimumMax + invertDecimal + decimal + invertDecimal + lengthMaximumMin + invertDecimal + decimal + invertDecimal + lengthMaximumMax + invertDecimal + decimal + invertDecimal + lowerCaseMin + invertDecimal + decimal + invertDecimal + lowerCaseMax + invertDecimal + decimal + invertDecimal + upperCaseMin + invertDecimal + decimal + invertDecimal + upperCaseMax + invertDecimal + decimal + invertDecimal + numeraryMin + invertDecimal + decimal + invertDecimal + numeraryMax + invertDecimal + decimal + invertDecimal + specialCharMin + invertDecimal + decimal + invertDecimal + specialCharMax + invertDecimal + insertstmtclose;
        Statement stmt;
        try {
            stmt = settings.createStatement();
            stmt.executeUpdate(sqlstmt);
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Database settings insert not possible.");
        }
    }

    public static void walletUpdateAccount(int accountId, String column, String value) {

        String insertstmt = "UPDATE keystash_wallet SET ";
        String insertstmtclose = ")";
        String where = " WHERE account_id = ";
        String equal = " = ";
        String decimal = ", ";
        String invertDecimal = "'";
        String sqlstmt = insertstmt + column + equal + invertDecimal + value + invertDecimal + where + accountId;
        Statement stmt;

        try {
            stmt = wallet.createStatement();
            stmt.executeUpdate(sqlstmt);
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Database wallet update not possible.");
        }
    }

    public static void walletUpdateSettings(int settingsId, String column, String value) {

        String insertstmt = "UPDATE keystash_settings SET ";
        String insertstmtclose = ")";
        String where = " WHERE settings_id = ";
        String equal = " = ";
        String decimal = ", ";
        String invertDecimal = "'";
        String sqlstmt = insertstmt + column + equal + invertDecimal + value + invertDecimal + where + settingsId;

        Statement stmt;
        try {
            stmt = settings.createStatement();
            stmt.executeUpdate(sqlstmt);
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Database settings update not possible.");
        }

    }

    public static void walletQuery(String sqlstmt) {

        try {
            Statement select = wallet.createStatement();
            ResultSet result = select.executeQuery(sqlstmt);
            ResultSetMetaData resultMetaData = result.getMetaData();
            int numberOfColumns = resultMetaData.getColumnCount();
            int rownum = 0;

            while (result.next()) {
                rownum++;

                for (int i = 1; i <= numberOfColumns; i++) {

                    if (i < numberOfColumns) {

                    }
                }

            }
        } catch (Exception e) {
            System.err.println("Database wallet query not possible.");
        }

    }

    public static int countAccountsWallet(String tableName) {

        try {
            Statement select = wallet.createStatement();

            int count;
            try ( ResultSet r = select.executeQuery("SELECT COUNT(*) AS rowcount FROM " + tableName) ) {
                r.next();
                count = r.getInt("rowcount");
            }

            return count;

        } catch (SQLException e) {
            System.err.println("Database wallet count not possible.");
        }
        return 0;

    }

    public static String selectFromWallet(String value, String tableName, String where, int whereEquals) {

        try {
            Statement select = wallet.createStatement();

            String v;
            try ( ResultSet r = select.executeQuery("SELECT " + value + " from " + tableName + " where " + where + " = " + whereEquals) ) {

                r.next();
                v = r.getString(1);
            }

            return v;

        } catch (SQLException e) {
            System.err.println("Database select from wallet not possible.");
        }
        return null;

    }

    public static String selectFromSettings(String value, String tableName, String where, int whereEquals) {

        try {
            Statement select = settings.createStatement();
            String v;

            try ( ResultSet r = select.executeQuery("SELECT " + value + " from " + tableName + " where " + where + " = " + whereEquals) ) {
                r.next();
                v = r.getString(1);
            }
            return v;
        } catch (SQLException e) {
            System.err.println("Database select from database not possible.");
        }
        return null;

    }

    public static void walletClose() {

        Statement stmt;
        try {
            stmt = wallet.createStatement();
            stmt.executeUpdate("SHUTDOWN");
            stmt.close();
        } catch (SQLException ex) {
            System.err.println("Close database wallet failed.");
        }
    }

}
